summaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
Diffstat (limited to 'tools')
-rw-r--r--tools/check_for_upgrade.sh9
-rwxr-xr-xtools/install.sh162
-rw-r--r--tools/uninstall.sh30
-rw-r--r--tools/upgrade.sh45
4 files changed, 174 insertions, 72 deletions
diff --git a/tools/check_for_upgrade.sh b/tools/check_for_upgrade.sh
index b2b356e0c..881bc6c49 100644
--- a/tools/check_for_upgrade.sh
+++ b/tools/check_for_upgrade.sh
@@ -26,6 +26,9 @@ fi
# oh-my-zsh directory.
[[ -w "$ZSH" ]] || return 0
+# Cancel upgrade if git is unavailable on the system
+whence git >/dev/null || return 0
+
if [ -f ~/.zsh-update ]
then
. ~/.zsh-update
@@ -41,10 +44,9 @@ then
then
_upgrade_zsh
else
- echo "[Oh My Zsh] Would you like to check for updates?"
- echo "Type Y to update oh-my-zsh: \c"
+ echo "[Oh My Zsh] Would you like to check for updates? [Y/n]: \c"
read line
- if [ "$line" = Y ] || [ "$line" = y ]; then
+ if [[ "$line" == Y* ]] || [[ "$line" == y* ]] || [ -z "$line" ]; then
_upgrade_zsh
else
_update_zsh_update
@@ -55,4 +57,3 @@ else
# create the zsh file
_update_zsh_update
fi
-
diff --git a/tools/install.sh b/tools/install.sh
index a53ac48ab..8cba52085 100755
--- a/tools/install.sh
+++ b/tools/install.sh
@@ -1,50 +1,122 @@
-set -e
+main() {
+ # Use colors, but only if connected to a terminal, and that terminal
+ # supports them.
+ if which tput >/dev/null 2>&1; then
+ ncolors=$(tput colors)
+ fi
+ if [ -t 1 ] && [ -n "$ncolors" ] && [ "$ncolors" -ge 8 ]; then
+ RED="$(tput setaf 1)"
+ GREEN="$(tput setaf 2)"
+ YELLOW="$(tput setaf 3)"
+ BLUE="$(tput setaf 4)"
+ BOLD="$(tput bold)"
+ NORMAL="$(tput sgr0)"
+ else
+ RED=""
+ GREEN=""
+ YELLOW=""
+ BLUE=""
+ BOLD=""
+ NORMAL=""
+ fi
-if [ ! -n "$ZSH" ]; then
- ZSH=~/.oh-my-zsh
-fi
+ # Only enable exit-on-error after the non-critical colorization stuff,
+ # which may fail on systems lacking tput or terminfo
+ set -e
-if [ -d "$ZSH" ]; then
- echo "\033[0;33mYou already have Oh My Zsh installed.\033[0m You'll need to remove $ZSH if you want to install"
- exit
-fi
+ CHECK_ZSH_INSTALLED=$(grep /zsh$ /etc/shells | wc -l)
+ if [ ! $CHECK_ZSH_INSTALLED -ge 1 ]; then
+ printf "${YELLOW}Zsh is not installed!${NORMAL} Please install zsh first!\n"
+ exit
+ fi
+ unset CHECK_ZSH_INSTALLED
-echo "\033[0;34mCloning Oh My Zsh...\033[0m"
-hash git >/dev/null 2>&1 && env git clone https://github.com/robbyrussell/oh-my-zsh.git $ZSH || {
- echo "git not installed"
- exit
+ if [ ! -n "$ZSH" ]; then
+ ZSH=~/.oh-my-zsh
+ fi
+
+ if [ -d "$ZSH" ]; then
+ printf "${YELLOW}You already have Oh My Zsh installed.${NORMAL}\n"
+ printf "You'll need to remove $ZSH if you want to re-install.\n"
+ exit
+ fi
+
+ # Prevent the cloned repository from having insecure permissions. Failing to do
+ # so causes compinit() calls to fail with "command not found: compdef" errors
+ # for users with insecure umasks (e.g., "002", allowing group writability). Note
+ # that this will be ignored under Cygwin by default, as Windows ACLs take
+ # precedence over umasks except for filesystems mounted with option "noacl".
+ umask g-w,o-w
+
+ printf "${BLUE}Cloning Oh My Zsh...${NORMAL}\n"
+ hash git >/dev/null 2>&1 || {
+ echo "Error: git is not installed"
+ exit 1
+ }
+ env git clone --depth=1 https://github.com/robbyrussell/oh-my-zsh.git $ZSH || {
+ printf "Error: git clone of oh-my-zsh repo failed\n"
+ exit 1
+ }
+
+ # The Windows (MSYS) Git is not compatible with normal use on cygwin
+ if [ "$OSTYPE" = cygwin ]; then
+ if git --version | grep msysgit > /dev/null; then
+ echo "Error: Windows/MSYS Git is not supported on Cygwin"
+ echo "Error: Make sure the Cygwin git package is installed and is first on the path"
+ exit 1
+ fi
+ fi
+
+ printf "${BLUE}Looking for an existing zsh config...${NORMAL}\n"
+ if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
+ printf "${YELLOW}Found ~/.zshrc.${NORMAL} ${GREEN}Backing up to ~/.zshrc.pre-oh-my-zsh${NORMAL}\n";
+ mv ~/.zshrc ~/.zshrc.pre-oh-my-zsh;
+ fi
+
+ printf "${BLUE}Using the Oh My Zsh template file and adding it to ~/.zshrc${NORMAL}\n"
+ cp $ZSH/templates/zshrc.zsh-template ~/.zshrc
+ sed "/^export ZSH=/ c\\
+ export ZSH=$ZSH
+ " ~/.zshrc > ~/.zshrc-omztemp
+ mv -f ~/.zshrc-omztemp ~/.zshrc
+
+ printf "${BLUE}Copying your current PATH and adding it to the end of ~/.zshrc for you.${NORMAL}\n"
+ sed "/export PATH=/ c\\
+ export PATH=\"$PATH\"
+ " ~/.zshrc > ~/.zshrc-omztemp
+ mv -f ~/.zshrc-omztemp ~/.zshrc
+
+ # If this user's login shell is not already "zsh", attempt to switch.
+ TEST_CURRENT_SHELL=$(expr "$SHELL" : '.*/\(.*\)')
+ if [ "$TEST_CURRENT_SHELL" != "zsh" ]; then
+ # If this platform provides a "chsh" command (not Cygwin), do it, man!
+ if hash chsh >/dev/null 2>&1; then
+ printf "${BLUE}Time to change your default shell to zsh!${NORMAL}\n"
+ chsh -s $(grep /zsh$ /etc/shells | tail -1)
+ # Else, suggest the user do so manually.
+ else
+ printf "I can't change your shell automatically because this system does not have chsh.\n"
+ printf "${BLUE}Please manually change your default shell to zsh!${NORMAL}\n"
+ fi
+ fi
+
+ printf "${GREEN}"
+ echo ' __ __ '
+ echo ' ____ / /_ ____ ___ __ __ ____ _____/ /_ '
+ echo ' / __ \/ __ \ / __ `__ \/ / / / /_ / / ___/ __ \ '
+ echo '/ /_/ / / / / / / / / / / /_/ / / /_(__ ) / / / '
+ echo '\____/_/ /_/ /_/ /_/ /_/\__, / /___/____/_/ /_/ '
+ echo ' /____/ ....is now installed!'
+ echo ''
+ echo ''
+ echo 'Please look over the ~/.zshrc file to select plugins, themes, and options.'
+ echo ''
+ echo 'p.s. Follow us at https://twitter.com/ohmyzsh.'
+ echo ''
+ echo 'p.p.s. Get stickers and t-shirts at http://shop.planetargon.com.'
+ echo ''
+ printf "${NORMAL}"
+ env zsh
}
-echo "\033[0;34mLooking for an existing zsh config...\033[0m"
-if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
- echo "\033[0;33mFound ~/.zshrc.\033[0m \033[0;32mBacking up to ~/.zshrc.pre-oh-my-zsh\033[0m";
- mv ~/.zshrc ~/.zshrc.pre-oh-my-zsh;
-fi
-
-echo "\033[0;34mUsing the Oh My Zsh template file and adding it to ~/.zshrc\033[0m"
-cp $ZSH/templates/zshrc.zsh-template ~/.zshrc
-sed -i -e "/^ZSH=/ c\\
-ZSH=$ZSH
-" ~/.zshrc
-
-echo "\033[0;34mCopying your current PATH and adding it to the end of ~/.zshrc for you.\033[0m"
-sed -i -e "/export PATH=/ c\\
-export PATH=\"$PATH\"
-" ~/.zshrc
-
-if [ "$SHELL" != "$(which zsh)" ]; then
- echo "\033[0;34mTime to change your default shell to zsh!\033[0m"
- chsh -s `which zsh`
-fi
-
-echo "\033[0;32m"' __ __ '"\033[0m"
-echo "\033[0;32m"' ____ / /_ ____ ___ __ __ ____ _____/ /_ '"\033[0m"
-echo "\033[0;32m"' / __ \/ __ \ / __ `__ \/ / / / /_ / / ___/ __ \ '"\033[0m"
-echo "\033[0;32m"'/ /_/ / / / / / / / / / / /_/ / / /_(__ ) / / / '"\033[0m"
-echo "\033[0;32m"'\____/_/ /_/ /_/ /_/ /_/\__, / /___/____/_/ /_/ '"\033[0m"
-echo "\033[0;32m"' /____/ ....is now installed!'"\033[0m"
-echo "\n\n \033[0;32mPlease look over the ~/.zshrc file to select plugins, themes, and options.\033[0m"
-echo "\n\n \033[0;32mp.s. Follow us at http://twitter.com/ohmyzsh.\033[0m"
-echo "\n\n \033[0;32mp.p.s. Get stickers and t-shirts at http://shop.planetargon.com.\033[0m"
-env zsh
-. ~/.zshrc
+main
diff --git a/tools/uninstall.sh b/tools/uninstall.sh
index 41d601576..bf2244be8 100644
--- a/tools/uninstall.sh
+++ b/tools/uninstall.sh
@@ -1,28 +1,34 @@
+read -r -p "Are you sure you want to remove Oh My Zsh? [y/N] " confirmation
+if [ "$confirmation" != y ] && [ "$confirmation" != Y ]; then
+ echo "Uninstall cancelled"
+ exit
+fi
+
echo "Removing ~/.oh-my-zsh"
-if [[ -d ~/.oh-my-zsh ]]
-then
+if [ -d ~/.oh-my-zsh ]; then
rm -rf ~/.oh-my-zsh
fi
echo "Looking for original zsh config..."
-if [ -f ~/.zshrc.pre-oh-my-zsh ] || [ -h ~/.zshrc.pre-oh-my-zsh ]
-then
+if [ -f ~/.zshrc.pre-oh-my-zsh ] || [ -h ~/.zshrc.pre-oh-my-zsh ]; then
echo "Found ~/.zshrc.pre-oh-my-zsh -- Restoring to ~/.zshrc";
- if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]
- then
- ZSHRC_SAVE=".zshrc.omz-uninstalled-`date +%Y%m%d%H%M%S`";
+ if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
+ ZSHRC_SAVE=".zshrc.omz-uninstalled-$(date +%Y%m%d%H%M%S)";
echo "Found ~/.zshrc -- Renaming to ~/${ZSHRC_SAVE}";
- mv ~/.zshrc ~/${ZSHRC_SAVE};
+ mv ~/.zshrc ~/"${ZSHRC_SAVE}";
fi
mv ~/.zshrc.pre-oh-my-zsh ~/.zshrc;
- source ~/.zshrc;
+ echo "Your original zsh config was restored. Please restart your session."
else
- echo "Switching back to bash"
- chsh -s /bin/bash
- source /etc/profile
+ if hash chsh >/dev/null 2>&1; then
+ echo "Switching back to bash"
+ chsh -s /bin/bash
+ else
+ echo "You can edit /etc/passwd to switch your default shell back to bash"
+ fi
fi
echo "Thanks for trying out Oh My Zsh. It's been uninstalled."
diff --git a/tools/upgrade.sh b/tools/upgrade.sh
index 5f0a81f1d..d5e7e8ba8 100644
--- a/tools/upgrade.sh
+++ b/tools/upgrade.sh
@@ -1,16 +1,39 @@
-printf '\033[0;34m%s\033[0m\n' "Upgrading Oh My Zsh"
+
+# Use colors, but only if connected to a terminal, and that terminal
+# supports them.
+if which tput >/dev/null 2>&1; then
+ ncolors=$(tput colors)
+fi
+if [ -t 1 ] && [ -n "$ncolors" ] && [ "$ncolors" -ge 8 ]; then
+ RED="$(tput setaf 1)"
+ GREEN="$(tput setaf 2)"
+ YELLOW="$(tput setaf 3)"
+ BLUE="$(tput setaf 4)"
+ BOLD="$(tput bold)"
+ NORMAL="$(tput sgr0)"
+else
+ RED=""
+ GREEN=""
+ YELLOW=""
+ BLUE=""
+ BOLD=""
+ NORMAL=""
+fi
+
+printf "${BLUE}%s${NORMAL}\n" "Updating Oh My Zsh"
cd "$ZSH"
if git pull --rebase --stat origin master
then
- printf '\033[0;32m%s\033[0m\n' ' __ __ '
- printf '\033[0;32m%s\033[0m\n' ' ____ / /_ ____ ___ __ __ ____ _____/ /_ '
- printf '\033[0;32m%s\033[0m\n' ' / __ \/ __ \ / __ `__ \/ / / / /_ / / ___/ __ \ '
- printf '\033[0;32m%s\033[0m\n' '/ /_/ / / / / / / / / / / /_/ / / /_(__ ) / / / '
- printf '\033[0;32m%s\033[0m\n' '\____/_/ /_/ /_/ /_/ /_/\__, / /___/____/_/ /_/ '
- printf '\033[0;32m%s\033[0m\n' ' /____/ '
- printf '\033[0;34m%s\033[0m\n' 'Hooray! Oh My Zsh has been updated and/or is at the current version.'
- printf '\033[0;34m%s\033[1m%s\033[0m\n' 'To keep up on the latest news and updates, follow us on twitter: ' 'http://twitter.com/ohmyzsh'
- printf '\033[0;34m%s\033[1m%s\033[0m\n' 'Get your Oh My Zsh swag at: ' 'http://shop.planetargon.com/'
+ printf '%s' "$GREEN"
+ printf '%s\n' ' __ __ '
+ printf '%s\n' ' ____ / /_ ____ ___ __ __ ____ _____/ /_ '
+ printf '%s\n' ' / __ \/ __ \ / __ `__ \/ / / / /_ / / ___/ __ \ '
+ printf '%s\n' '/ /_/ / / / / / / / / / / /_/ / / /_(__ ) / / / '
+ printf '%s\n' '\____/_/ /_/ /_/ /_/ /_/\__, / /___/____/_/ /_/ '
+ printf '%s\n' ' /____/ '
+ printf "${BLUE}%s\n" "Hooray! Oh My Zsh has been updated and/or is at the current version."
+ printf "${BLUE}${BOLD}%s${NORMAL}\n" "To keep up on the latest news and updates, follow us on twitter: https://twitter.com/ohmyzsh"
+ printf "${BLUE}${BOLD}%s${NORMAL}\n" "Get your Oh My Zsh swag at: http://shop.planetargon.com/"
else
- printf '\033[0;31m%s\033[0m\n' 'There was an error updating. Try again later?'
+ printf "${RED}%s${NORMAL}\n" 'There was an error updating. Try again later?'
fi